#include "hmc6352.h"
#include <Wire.h>

#include "WProgram.h"



Hmc6352::Hmc6352()
{
  Wire.begin();
}


float Hmc6352::getHeading()
{
  byte val = 0;
  byte data[2];
  int  j, frac;

  Wire.beginTransmission(0x21);
  Wire.send(0x41); //A
  Wire.endTransmission();
  delay(8); //6000 microseconds minimum 6 ms 

  Wire.requestFrom(0x21, 2);
  j = 0;
  while(Wire.available())
  {
    char c = Wire.receive();
    data[j] = c;
    j++;
  }
  frac = data[0]*256 + data[1];
  
  return (frac/10.0);
}


void Hmc6352::wake()
{
  Wire.beginTransmission(0x21);
  Wire.send(0x57); //W wake up exit sleep mode
  Wire.endTransmission();
  
}

void Hmc6352::sleep()
{
  Wire.beginTransmission(0x21);
  Wire.send(0x53); //S enter sleep mode
  Wire.endTransmission();
  
}

